class Particle(object):
    """ Represents a particle: position, velocity, mass"""

    def __init__(self, x = 0., y = 0., z = 0.,
                      vx = 0., vy = 0., vz = 0., m = 1.):

        self.x = x
        self.y = y
        self.z = z

        self.vx = vx
        self.vy = vy
        self.vz = vz

	self.m = m

    def __str__(self):
        return  "Position: {} {} {}\nVelocity: {} {} {}\nMass: {}"\
              .format(self.x,self.y,self.z,self.vx,self.vy,self.vz,self.m)

    def __add__(self,other):
        """ returns center of mass position, velocity, sum(mass) """

        pcm = Particle()
        pcm.m = self.m + other.m
        pcm.x = (self.m*self.x + other.m*other.x) / pcm.m
        pcm.y = (self.m*self.y + other.m*other.y) / pcm.m
        pcm.z = (self.m*self.z + other.m*other.z) / pcm.m
   
        pcm.vx = (self.m*self.vx + other.m*other.vx) / pcm.m
        pcm.vy = (self.m*self.vy + other.m*other.vy) / pcm.m
        pcm.vz = (self.m*self.vz + other.m*other.vz) / pcm.m
        return pcm

    def update(self, pos_new, vel_new):
        self.positions.append(pos_new)
        self.velocities.append(vel_new)

    def collision_inelastic(p1,p2):
        """ returns center of mass position, velocity, sum(mass) """
        pcm = Particle()
        pcm.m = p1.m + p2.m
        pcm.x = (p1.m*p1.x + p2.m*p2.x) / pcm.m
        pcm.y = (p1.m*p1.y + p2.m*p2.y) / pcm.m
        pcm.z = (p1.m*p1.z + p2.m*p2.z) / pcm.m

        pcm.vx = (p1.m*p1.vx + p2.m*p2.vx) / pcm.m
        pcm.vy = (p1.m*p1.vy + p2.m*p2.vy) / pcm.m
        pcm.vz = (p1.m*p1.vz + p2.m*p2.vz) / pcm.m
        return pcm

    def print_p(p):
        print "Position: {} {} {}\nVelocity: {} {} {}\nMass: {}"\
              .format(p.x,p.y,p.z,p.vx,p.vy,p.vz,p.m)

    def accrete(p,dm):
        p.m += dm
